program SRAM;

uses stringhe,pila_int,ambienti,termini;



        type    etichetta = integer;
                codice_comando = ( assegnamento, ifeq, ifgt, ifempty, b_goto, b_push, b_top, b_pop, b_inpit, b_output, nop);
                jumptable = array[1..25] of etichetta;

        type  comando = object
              cod:  codice_comando;
              id1, id2: varide;
              exp:  termine;
              et:   etichetta;
              procedure newcom;
              end;


              istruzione = object
                et:  etichetta;
                com: comando;
                end;


        procedure comando.newcom;
        begin
             cod:=nop;
             id1:=chr(0);
             id2:=chr(0);
             exp:=NIL;
             et:=-1;
        end;

const max_lun_prog = 1000;

               

type programma = array[0..max_lun_prog] of istruzione;
     a = array[codice_comando] of string;


var prog: programma;
    lun_prog: integer;




{
procedure caricamento_e_parsing;
var errore : boolean;
prog_file : string;
begin



errore := false;

     writeln('inserire il nome del programma');
     readln(prog_file);

     while (not eof (prog_file)) and (not errore) do begin
        readln (prog_file, linea_corrente);

        if parse (linea_corrente) then incrementa (contatore_linee)

        else begin

           riporta_errore_alla_lina (contatore_linee);
           errore:= true
        end
     end
end;
}



procedure esegui_programma;

var amb: ambiente;
     cp: integer;       {contatore programma, e' usato come indice su su prog}
     stack: pila;

begin
   inizializzazioni_esegui(cp,stack);          {cp = 1 e lo stack e' vuoto}
   while cp <= lun_prog do
      with prog[cp].com do
         case cod of
            ass:   begin
                      assegnamento (id1,eval_term(exp,amb),amb);
                      cp:= cp+1
                   end;
            ifeq:  if eval_var(id1,amb) = eval_var(id2,amb) then
                          cp:= indice_dell'_etichetta (et)
                   else cp:= cp+1;

            ifgt:  if eval_var(id1,amb) > eval_var(id2,amb) then
                          cp:= indice_dell'_etichetta (et)
                   else cp:= cp+1;
            ifemp: if isempty (stack) then
                          cp:= indice_dell'_etichetta (et)
                   else cp:= cp+1;
            goto:  cp:= indice_dell'_etichetta (et);
            pushc: begin
                      stack:= push (eval_term(exp,amb),stack);
                      cp:= cp+1
                   end;
            popc:  begin
                      stack:= pop (stack);
                      cp:= cp+1
                   end;
            topc:  begin
                      assegnamento (id1,top(stack),amb);
                      cp:= cp+1
                   end;
            inpc:  begin
                      readln(intero)
                      assegnamento (id1,intero,amb);
                      cp:= cp+1
                   end;
            outc:  begin
                      writeln(eval_term(exp,amb));
                      cp:= cp+1
                   end
            end
      end
end
   


begin    { main }

     inizializzazione_SRAM;
     while opzione <> esci do begin
          stampa_menu;
          leggi_opzione (opzione);
          case opzione of
              carica: caricamento_e_parsing;
              lista:  stampa_listato;
              esegui: esegui_programma;
              esci:   nessuna_azione
          end
     end
end