
unit pila_int;

interface

type  pila = ^pila_el;

      pila_el = record
           el: integer;
           next: pila
      end;

procedure nuova_pila (var p: pila);
{post:  dealloca e reinizializza la pila p}

function push (x: integer; p: pila): pila;
{post:  ritorna la pila che si ottiene aggiungendo x a p, }
{       come elemento emergente }

function pop (p: pila): pila;
{pre:  la pila p non e' vuota}
{post: ritorna la pila p rimuovendone l'elemento emergente}

function top (p: pila): integer;
{pre:  la pila p non e' vuota }
{post: ritorna l'elemento emergente di p }

function isempty (p: pila): boolean;
{post: true se p e' vuota }


implementation

procedure nuova_pila (var p: pila);
{post:  dealloca e reinizializza la pila p}
begin
  if not isempty(p) then
  begin
  if not isempty( p^.next ) then  { + di 1 elemento }
     nuova_pila(p^.next);
  dispose(p);
  p:=NIL;
  end;
end;




function push (x: integer; p: pila): pila;
{post:  ritorna la pila che si ottiene aggiungendo x a p, }
{       come elemento emergente }
var t: pila;
begin
t:=new(pila);
t^.el:=x;
t^.next:=p;
push:=t;
end;

function pop (p: pila): pila;
{pre:  la pila p non e' vuota}
{post: ritorna la pila p rimuovendone l'elemento emergente}
begin
if not isempty(p) then begin
   pop:=p^.next;
   dispose(p);
   end
else pop:=NIL;
end;

function top (p: pila): integer;
{pre:  la pila p non e' vuota }
{post: ritorna l'elemento emergente di p }
begin
if not isempty(p) then
top:=p^.el
else top:=-1;
end;

function isempty (p: pila): boolean;
{post: true se p e' vuota }

begin
isempty := (p=NIL);
end;


end.

