
unit stringhe;

interface
const  MAXLINEA = 80;
       MAXPAROLA = 12;
       TAB       = chr(9);
type linea = string[MAXLINEA];
     parola = string[MAXPAROLA];

function match (p: parola; l:linea; var j: integer): boolean;
{pre:  lun(p) <= lun(l)-j+1}
{post: true se p e' un prefisso di l[j..lun(l)] }

procedure skip (l: linea; var i: integer);
{pre:  i <= lun(l) }
{post: i:= il minimo indice >= i tale che l[i] <> ' ', se esiste }
{      i:= length(l)+1 altrimenti}

procedure compatta ( var l: linea);
{post: elimina gli spazi e i TAB all' interno della stringa l }

implementation

function match (p: parola; l:linea; var j: integer): boolean;
{pre:  lun(p) <= lun(l)-j+1}
{post: true se p e' un prefisso di l[j..lun(l)] }
var i : integer;
begin
 i:=1;
 if(length(p)<=((length(l)-j)+1)) then
 while((p[i]=l[j+i-1]) and (i <= length(p) )) do inc(i);
 if i <= length(p) then match := false
    else begin
     match := true;
     j:=j+i-1;
     end;
end;

procedure skip (l: linea; var i: integer);
{pre:  i <= lun(l) }
{post: i:= il minimo indice >= i tale che l[i] <> ' ', se esiste }
{      i:= length(l)+1 altrimenti}

begin
  while ( (l[i]=' ') and (i <= length(l))) do inc(i);
end;

procedure compatta ( var l: linea);
var i,j:integer;
begin
j:=1;
 for i:=1 to length(l) do
  if ((l[i]<>' ') and (l[i] <> TAB)) then
   begin
    l[j]:=l[i];
    inc(j);
   end;
  delete(l,j,MAXLINEA);
end;

end.