program test;

uses stringhe,pila_int,ambienti,termini,comandi,crt;

type opzione = ( exit,load,list,run);

const NORMALE = 13;
      SFONDO = 3;
      SELEZIONE = 10;
      ESC=chr(27);
      ENTER=chr(13);
      SPACE=chr(32);
      SU=chr(72);
      GIU=chr(80);
      SX=chr(75);
      DX=chr(77);


var    lun_prog: integer;

var  programname,l,w: linea;
     stack: pila;
     i,n:integer;
     am:ambiente;
     c:char;
     b:boolean;
     t : termine;
     a:ambiente;
     comm : codice_comando;
     lineno :integer;
     f      : text;
     o: opzione;

procedure inizializza;
var
i:  integer;
c:  char;

begin
l:='';
programname:='';
b:=true;
pc:=0;

c:='a';
a:=nuovoambiente;
for i:=0 to 25 do
    begin
    assegnamento(c,0,a);
    c:=succ(c);
    end;

TextBackground(Black);{ Clear screen }
ClrScr;

end;


procedure stampa_listato(from,toline : integer );
begin
Window(1,1, 79,19);
    TextBackground(BLACK);
    ClrScr;

if ((from <= toline) and ( toline < pc) ) then
 for i:=from to toline do begin
  stampa_comando(i);
  writeln(';');
  end;
end;



function caricamento_e_parsing: boolean;
var i,IOCode:integer;
begin
Window(1,1, 79,19);
TextBackground(BLACK);
ClrScr;

{$I-}
repeat
   if programname='' then
    begin
    writeln('immetti il nome del file .bas');
    readln(programname);
    end;
   i:=(length(programname)-2);
   if not match('bas',programname,i) then
    programname:=programname+'.bas';
     assign(f,programname);
     reset(f);
     IOCode:=IOResult;
   if IOCode <> 0 then writeln ('Il file ',l,' non esiste');
   l:='';
until  IOCode = 0;
{$I+}

lineno:=0;
    while (not eof(f) and b) do begin
          readln(f,l);
          i:=1;
          inc(lineno);
          compatta(l);
          if length(l)>1 THEN
          prg(l,i,b);
          if not b then writeln('Errore alla linea',lineno);
          end;

caricamento_e_parsing:=b;
if b then lun_prog:=pc-1 else begin
  lun_prog:=0;
  programname:='';

  end;

close(f);
end;

function stampa_menu: opzione;
var o1: opzione;
    opt: array[opzione] of string;

procedure refresh(mode: integer);
begin
 textcolor(mode);
 gotoxy(10*(ord(o)+1),4);
 write(opt[o]);
end;


begin
  opt[exit]:='Exit';
  opt[load]:='Load';
  opt[list]:='List';
  opt[run]:='Run';

    Window(1,20,79,25);
    TextBackground(SFONDO);
    ClrScr;
Textcolor(NORMALE);
gotoxy(20,2);
writeln('Scegli Opzione');
gotoxy(46,5);
   write('< Asp Basic 1.0>');

for o1:=exit to run do  begin
 gotoxy(10*(ord(o1)+1),4);
 write(opt[o1]);
 end;


if programname<>'' then begin
   opt[run]:='RUN <'+programname+'>';
   o:=run;
   end
   else o:=load;

refresh(SELEZIONE);

repeat

 c:= readkey;
 if ord(c)=0 then  c:=readkey;
   case c of
   dx   : begin refresh(NORMALE); if o = run then o:=exit else o:=succ(o); refresh(SELEZIONE); end;
   sx   : begin refresh(NORMALE); if o = exit then o:=run else o:=pred(o); refresh(SELEZIONE); end;
   end;

until (c = SPACE) or ( c= ENTER ) or (c=ESC);

if c=ESC then o:= exit;

stampa_menu:=o;

end;



procedure esegui_programma;

var  cp: integer;
     amb : ambiente;
     intero : integer;

begin
     { inizializzazioni }
   cp:=0;
   amb:=a;
   Window(1,1, 79,19);
   TextBackground(BLACK);
   ClrScr;
   nuova_pila(stack);

   while cp <= lun_prog do
      with prog[cp].com do
         case cod of
            assegna:   begin
                      assegnamento (id1,eval_term(exp,amb,b),amb);
                      cp:= cp+1
                   end;
            iflt:  if eval_var(id1,amb) < eval_var(id2,amb) then
                          cp:= jmptbl[ord(et)-ord('A')]
                   else cp:= cp+1;

            ifeq:  if eval_var(id1,amb) = eval_var(id2,amb) then
                          cp:=jmptbl[ord(et)-ord('A')]
                   else cp:= cp+1;

            ifgt:  if eval_var(id1,amb) > eval_var(id2,amb) then
                          cp:= jmptbl[ord(et)-ord('A')]
                   else cp:= cp+1;
            ifempty: if isempty (stack) then
                          cp:= jmptbl[ord(et)-ord('A')]
                   else cp:= cp+1;
            b_goto:  cp:=jmptbl[ord(et)-ord('A')];

            b_push: begin
                      stack:= push (eval_term(exp,amb,b),stack);
                      cp:= cp+1
                   end;
            b_pop:  begin
                      stack:= pop (stack);
                      cp:= cp+1
                   end;
            b_top:  begin
                      assegnamento (id1,top(stack),amb);
                      cp:= cp+1
                   end;
            b_input:  begin
                      write('Imetti ',id1,' ');
                      readln(intero);
                      assegnamento (id1,intero,amb);
                      cp:= cp+1
                   end;
            b_output:  begin
                      writeln(eval_term(exp,amb,b));
                      cp:= cp+1
                   end
            end
end;



begin
inizializza;
stack:=nil;

if ParamCount > 0 then
 begin
 programname:=Paramstr(1);
 b:=caricamento_e_parsing;
 end;

repeat

o:=stampa_menu;

window(1,1,79,3);

case o of

load :   begin inizializza;b:=caricamento_e_parsing;end;

list :   if b then stampa_listato(0,pc-1) else writeln('Caricare prima il programma');

run  :   if ( b and (pc > 0)) then esegui_programma else writeln('Caricare prima il programma');

end;

until o=exit;

Window(1,1, 79,25);
TextBackground(BLACK);
TextColor(NORMALE);
ClrScr;

end.
