program SRAM;

uses stringhe,pila_int,ambienti,termini;



        type    etichetta = integer;
                codice_comando = ( assegnamento, ifeq, ifgt, ifempty, b_goto, b_push, b_top, b_pop, b_inpit, b_output, nop);
                jumptable = array[1..25] of etichetta;

        type  comando = object
              cod:  codice_comando;
              id1, id2: varide;
              exp:  termine;
              et:   etichetta;
              procedure newcom;
              end;


              istruzione = object
                et:  etichetta;
                com: comando;
                end;


        procedure comando.newcom;
        begin
             cod:=nop;
             id1:=chr(0);
             id2:=chr(0);
             exp:=NIL;
             et:=-1;
        end;

const max_lun_prog = 1000;

               

type programma = array[0..max_lun_prog] of istruzione;
     a = array[codice_comando] of string;


var prog: programma;
    lun_prog: integer;




{
procedure caricamento_e_parsing;
var errore : boolean;
prog_file : string;
begin



errore := false;

     writeln('inserire il nome del programma');
     readln(prog_file);

     while (not eof (prog_file)) and (not errore) do begin
        readln (prog_file, linea_corrente);

        if parse (linea_corrente) then incrementa (contatore_linee)

        else begin

           riporta_errore_alla_lina (contatore_linee);
           errore:= true
        end
     end
end;
}




begin    { main }

     inizializzazione_SRAM;
     while opzione <> esci do begin
          stampa_menu;
          leggi_opzione (opzione);
          case opzione of
              carica: caricamento_e_parsing;
              lista:  stampa_listato;
              esegui: esegui_programma;
              esci:   nessuna_azione
          end
     end
end